#include <stdio.h>
#include <string>
#include <list>
#include <iterator>
#include <iostream>
using namespace std;

#ifndef AUTOLIST_H
#define AUTOLIST_H

/**
 * Class for holding a pair of group:directory data
 */
class  AutoTouple {
    public: 
        string group;
        string directory;
        AutoTouple() {
            this->group = "";
            this->directory = "";
        }
        
        AutoTouple(string group, string directory) {
            this->group = group;
            this->directory = directory;
        }
        
        AutoTouple &operator==(AutoTouple &that) {
            this->group = that.group;
            this->directory = that.directory;
            return that;
        }
};

/**
 * Loads a set of directories to scan from a config file
 * and places into a list of AutoTouple objects
 */
class AutoList {
    public:
        AutoList();
        ~AutoList();
        AutoList(string filename);
        void loadFile(string filename);
        list<AutoTouple>::const_iterator begin();
        list<AutoTouple>::const_iterator end();
        void dump();
        
    private:
        int parseLine(string line, AutoTouple *result);
        void extractGroupName(string line, string &name);
        
        list<AutoTouple> directoryList;
};

#endif
